
#include <condefs.h>
#pragma hdrstop

//dclaration forward
class TB;

//classe TA avec son pointeur sur un TB qui lui est pass ds sa cration
class TA{
        public:
        TList* lstpB;
        //constructeur
        TA();
        //ajout d'une instance de TB
        void add(TB* prmB);
        //destructeur
        ~TA();
        };

//description de TB, pas de navigabilit restreinte, donc pointeur sur TA
class TB{
        public:
        TA* pA;
        };

//implmentation du constructeur de TA
TA::TA()
{
        lstpB = new TList();

}

//ajout d'un lment de TB dans la liste
void TA::add(TB* prmB)
{
        lstpB->Add(prmB);
        prmB->pA = this;//la navigabilit n'est pas restreinte !!!
}

//implmentation du destructeur de TA !!! le noeud du problme
TA::~TA()
{
        TB* pB;
        //dtruire toutes les instances
        for (int i = lstpB->Count-1;i>=0;i--)
                {
                        //rcuprer un pointeur sur l'objet
                        pB = (TB*)lstpB->Items[i];
                        //dtruire l'objet
                        delete pB;
                        //dtruire la rfrence dans la liste
                        //pas de pbm mme si la liste est dj dtruite
                        lstpB->Delete(i);
                }
        //dtruire la liste polymorphe qui ne rfrenait plus rien de toute manire
        delete lstpB;
}

//---------------------------------------------------------------------------
#pragma argsused
int main(int argc, char* argv[])
{

        TA* a;
        a = new TA();

        //ajout d'un TB dans la liste
        a->add(new TB());

        delete a;//dtruit automatiquement b

        return 0;
}
 